// 7 seg multiplex example by kalobyte.com 2010
#define F_CPU 1000000

#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>



#define PORT_SEG	PORTC
#define PORT_CAT	PORTB
#define DDR_SEG		DDRC
#define DDR_CAT		DDRB

#define MAX_DIGS	4


const char cathode[10]={0x3F, 0x06, 0x5B, 0x4F, 0x66, 0x6D, 0x7D, 0x07, 0x7F, 0x6F}; // katode
char current_dig, cat_shift=1, digs[MAX_DIGS];
int out=0;

ISR(TIMER0_OVF_vect){
 
 if(cat_shift==2)
 PORT_SEG = digs[current_dig]|0x80;
 else
 PORT_SEG = digs[current_dig];

 PORT_CAT &=0xf0;
 PORT_CAT |= cat_shift;
 
 cat_shift<<=1;
 
 if(cat_shift>8){ 	cat_shift=1;} // or ==16 or (0x04)
 
 current_dig++;
 if(current_dig>3) {current_dig = 0;}
TCNT0 = 0xcc;

}

void disp_update(void){
char j;

	for(j=0;j<MAX_DIGS;j++){

		digs[j] = cathode[out%10];
		out = out/10;
	}
}

int main(void){
int aaa=0;

DDR_SEG = 0xFF;
PORT_SEG = 0x00;

DDR_CAT = 0xFF;
PORT_CAT = (1<<4);

TCCR0 = (1<<CS01)|(1<<CS00); //8
TCNT0 = 0xcc; // 300hz

TIMSK |= (1<<TOIE0);
TIFR |= (1<<TOV0);
sei();


//disp_update();
while(1){
disp_update();
_delay_ms(1000);

out = aaa++;
	
}

return 0;
}